package cn.com.do1.component.bi.gateway.config.DynamicRoute;


import cn.hutool.core.util.ObjectUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 动态路由转换器
 */
public class DynamicRouteConfigConverter {


    private final static Map<String, List<String>>  instanceToTenantIds=new HashMap<>();

    private final static Map<String, List<String>>  tenantIdToInstances=new HashMap<>();

    public static Map<String, List<String>>  getTenantIdToInstances(){
        return tenantIdToInstances;
    }
    public static Map<String, List<String>> getInstanceToTenantIds(){
        return instanceToTenantIds;
    }


    public static Map<String, List<String>> convertToInstanceToTenantIds(List<RouteInfo> routeInfos){
        for (RouteInfo routeInfo:routeInfos){
            DynamicRouteConfigConverter.instanceToTenantIds.putAll(routeInfo.getInstanceToTenantIds());
        }
        return instanceToTenantIds;
    }


    public static Map<String, List<String>> convertToTenantIdToInstances(List<RouteInfo> routeInfos){
        routeInfos.stream().forEach(routeInfo -> {
            if (ObjectUtil.isNotEmpty(routeInfo.getInstanceToTenantIds())){
                routeInfo.getInstanceToTenantIds().entrySet().stream().forEach(entry -> entry.getValue().stream().forEach(tenantId -> {
                    String instanceTenantIdKey = routeInfo.getId() + tenantId;
                    List<String> instances = tenantIdToInstances.getOrDefault(instanceTenantIdKey, new ArrayList<String>());
                    instances.add( entry.getKey());
                    tenantIdToInstances.put(instanceTenantIdKey,instances);
                }));
            }

        });
        return tenantIdToInstances;

    }

}
