package cn.com.do1.component.bi.gateway.config.DynamicRoute;

import com.alibaba.fastjson.JSON;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 路由信息配置
 */
public class RouteInfo {
    /**
     * 路由规则id
     */
    private String id;

    /**
     * 服务实例对应租户id
     */
    private Map<String, List<String>> instanceToTenantIds;

    /**
     * 默认路由规则
     */
    private String defaultUri;

    /**
     * 断言请求路径
     */
    private List<String> predicatesPaths;

    /**
     * 过滤器重写路径匹配
     */
    private Map<String,String> rewritePathMap;
    private Map<String,String> filters;

    public Map<String, String> getRewritePathMap() {
        return rewritePathMap;
    }

    public void setRewritePathMap(Map<String, String> rewritePathMap) {
        this.rewritePathMap = rewritePathMap;
    }

    public List<String> getPredicatesPaths() {
        return predicatesPaths;
    }

    public void setPredicatesPaths(List<String> predicatesPaths) {
        this.predicatesPaths = predicatesPaths;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Map<String, List<String>> getInstanceToTenantIds() {
        return instanceToTenantIds;
    }

    public void setInstanceToTenantIds(Map<String, List<String>> instanceToTenantIds) {
        this.instanceToTenantIds = instanceToTenantIds;
    }

    public String getDefaultUri() {
        return defaultUri;
    }

    public void setDefaultUri(String defaultUri) {
        this.defaultUri = defaultUri;
    }

    public static void main(String[] args) {
        RouteInfo routeInfo = new RouteInfo();
        routeInfo.setId("bi-system");
        List<String> strings = new ArrayList<>();
        strings.add("1");
        strings.add("3");
        strings.add("4");
        List<String> strings1 = new ArrayList<>();
        strings1.add("2");
        List<String> predicatesPaths = new ArrayList<>();
        predicatesPaths.add("/system/**");
        Map<String, List<String>> stringListHashMap = new HashMap<>();
        stringListHashMap.put("lb://bi-system-1",strings);
        stringListHashMap.put("lb://bi-system-2",strings1);
        routeInfo.setInstanceToTenantIds(stringListHashMap);
        routeInfo.setDefaultUri("lb://bi-system");
        routeInfo.setPredicatesPaths(predicatesPaths);
        Map<String, String> stringStringHashMap = new HashMap<>();

        stringStringHashMap.put("'/' + serviceId.replace('bi-', '') + '/(?<remaining>.*)'","'/${remaining}'");
        routeInfo.setRewritePathMap(stringStringHashMap);
        List<RouteInfo> routeInfos = new ArrayList<>();
        routeInfos.add(routeInfo);
        String s = JSON.toJSONString(routeInfos);

        List<RouteInfo> routeInfos1 = JSON.parseArray(s, RouteInfo.class);
        System.out.println(s);
    }
}
