package cn.com.do1.component.bi.gateway.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.context.annotation.Configuration;

import java.util.ArrayList;
import java.util.List;

@Configuration
@RefreshScope
@Data
@ConfigurationProperties(prefix = "encrypt-decrypt")
public class ReqDecryptAndRespEncryptConfig {
    /**
     * 开启req的body解密，true开启
     */
    private Boolean reqDecrypt = false;
    /**
     * 是否开启Response加密，true开启
     */
    private Boolean respEncrypt = false;
    /**
     * 加解密白名单，白名单内url不处理
     */
    private List<String> whiteUrl = new ArrayList<>();
    /**
     *  rsa加密公钥
     */
    private String rsaPublicKey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC9Z3S1r2wPogXFY2UH2vzBgzUEdvXDq6j0DHnJ5YU5pF" +
            "Ipgnz+G1Uf+5a5VzDcANrCT/GVqZAKPwbQM776eDv/xy1i4sS7wsI9m6pKQ3HSAJl1knT36qfKthMd6VdOQLAZuf9pH3ccbpO3GiJNWAfee/nJ" +
            "egPK0Xle4Fl114vaiQIDAQAB";
    /**
     * rsa加密私钥
     */
    private String rsaPrivateKey = "MIICeAIBADANBgkqhkiG9w0BAQEFAASCAmIwggJeAgEAAoGBAL1ndLWvbA+iBcVj" +
            "ZQfa/MGDNQR29cOrqPQMecnlhTmkUimCfP4bVR/7lrlXMNwA2sJP8ZWpkAo/BtAz" +
            "vvp4O//HLWLixLvCwj2bqkpDcdIAmXWSdPfqp8q2Ex3pV05AsBm5/2kfdxxuk7ca" +
            "Ik1YB957+cl6A8rReV7gWXXXi9qJAgMBAAECgYBJpwp2gHHoHlxaJs2p4Vl6stgS" +
            "FWR6o60+wf82KL/G64RbyfdrJRvUJRS2nBZO5zIqb8YFKfvuUBYJLqYsZkcGA58H" +
            "rxIt18bwdtbF3NEgPNLfnMhisD4KcMeBWySe+OlITiFY2IVMtCHAGT/lhSphkTru" +
            "UoRc4VfmFRLBy3g/hQJBAN0HeuFQS2zXeAItc6E7YoInTQb01Fm4Ax1pmViQQCke" +
            "Z6+Qe15jvktlppYJ0DM96lSPpDcBDJeMqM9vu5anBo8CQQDbXwo1VEkE+cROU+Cc" +
            "0YqvxDFJonp9iDza2ZzO1ilo0lLZWKYdG41gFDdSACwCNFq39X769c+eCV2b5iH6" +
            "J9lnAkEAvrrarZ1lSMnydCaWljYxflC9plgU+krQ3UunmQX5Z8ImBRjvbHcz2cog" +
            "424abG1sTYYaVaChJhGqBj7LqGf/PwJBAIlo18Ed4XsvZEpX+drg2klM0D66epWF" +
            "L/E53CInPdr9241vHOYgqwaiwyAnIWnkF2shaH+UV487eJo9pczHB0MCQQCwqgF6" +
            "rs6IyoFb/acqVm0mH5o6ROPthW5CobjoO7R3YcKQ1Mr5iHZcYKOPTnibLOlclEsH" +
            "CrPUk5sdCSkjd9NP";
}
