package cn.com.do1.component.bi.gateway.ctl;

import cn.com.do1.component.bi.gateway.config.ReqDecryptAndRespEncryptConfig;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/env")
public class GatewayController {
    @Autowired
    private ReqDecryptAndRespEncryptConfig reqDecryptAndRespEncryptConfig;

    @GetMapping("secret")
    public ResponseEntity<String> secret() {
        JSONObject json = new JSONObject();
        json.put("code",0);
        JSONObject sonJson = new JSONObject();
        if(reqDecryptAndRespEncryptConfig.getReqDecrypt() || reqDecryptAndRespEncryptConfig.getRespEncrypt()){
            sonJson.put("reqDecrypt",reqDecryptAndRespEncryptConfig.getReqDecrypt());
            sonJson.put("respEncrypt",reqDecryptAndRespEncryptConfig.getRespEncrypt());
            sonJson.put("publicKey", reqDecryptAndRespEncryptConfig.getRsaPublicKey());
            sonJson.put("privateKey", reqDecryptAndRespEncryptConfig.getRsaPrivateKey());
        }
        json.put("data",sonJson);
        return ResponseEntity.ok(json.toString());
    }
}