package cn.com.do1.component.bi.gateway.util.encrypt;

import lombok.extern.slf4j.Slf4j;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.io.IOException;
import java.util.Base64;

@Slf4j
public class AESEncryptUtil {

    public AESEncryptUtil() {
    }

    /**
     * 加密
     * @param input
     * @param key
     * @return
     */
    public static String encrypt(String input, String key) {

        String result = null;
        try {
            byte[] crypted = null;
            SecretKeySpec skey = new SecretKeySpec(key.getBytes(), "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skey);
            crypted = cipher.doFinal(input.getBytes("UTF-8"));
            result = encryptBASE64(crypted);
        } catch (Exception e) {
            System.out.println(e.toString());
        }
        return result;
    }
    public static void main(String[] args) throws Exception {
        String key = "niaze7pp0zho1mgp";
        String str = encrypt("{\"type\":2,\"pageSize\":50,\"currPage\":1}",key);
        System.out.println(str);
        System.out.println(decrypt(str,key));
    }
    /**
     * 解密
     * @param input
     * @param key
     * @return
     */
    public static String decrypt(String input, String key) {
        String result = null;
        try {
            byte[] output = null;
            SecretKeySpec skey = new SecretKeySpec(key.getBytes(), "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skey);
            output = cipher.doFinal(decryptBASE64(input));
            result = new String(output, "UTF-8");
        } catch (Exception e) {
            log.info(e.toString());
        }
        return result;
    }

    public static byte[] decryptBASE64(String key) throws IOException {
        return Base64.getDecoder().decode(key);
    }

    public static String encryptBASE64(byte[] key) {
        return Base64.getEncoder().encodeToString(key);
    }


}
